use base64;

// bas
fn b64encode(data: Vec<u8>) -> String {
    base64::encode_config(&data, base64::URL_SAFE)
}

fn b64decode(data: &str) -> Vec<u8> {
    base64::decode_config(&data, base64::URL_SAFE).unwrap()
}

fn xor(data: &[u8], key: u8) -> Vec<u8> {
    let mut encoded: Vec<u8> = Vec::new();
    for byte in data {
        encoded.push((key ^ byte) & 0xFF);
    }
    return encoded;
}

pub fn encode(data: String, key: u8) -> String {
    let xor_bytes = xor(data.as_bytes(), key);
    return b64encode(xor_bytes);

}

pub fn decode(data: String, key: u8) -> String {

    let data = b64decode(&data[..]);
    return String::from_utf8_lossy(&xor(&data, 0xF5)).to_string();
}


